import sqlite3
import json
import pandas as pd
from pandas import ExcelWriter

CATEGORY_DB_PATH = '/var/lib/safesquid/category/category.db';
#CATEGORY_DB_PATH = './test_files/category.db'; # Testing using Ganpat Server

CATEGORY_DB_SQL_QUERY = 'SELECT * from PRIVATE_CATEGORY;' 

sqlite3_db_connection = sqlite3.connect(CATEGORY_DB_PATH)

db_cursor = sqlite3_db_connection.cursor()

category_db_result_set = db_cursor.execute(CATEGORY_DB_SQL_QUERY);

category_list = {}
category_list_json = []

for one_row in category_db_result_set:
    website_name = one_row[0];
    website_category_list = one_row[1];
    for one_category_name in website_category_list.split(','):
        if one_category_name != '':
            if one_category_name in category_list.keys():
                category_list.get(one_category_name).append(website_name);
            else:
                category_list[one_category_name] = [website_name]
            
sqlite3_db_connection.close() # Close the DB Connection

print(f"Category DB Path: {CATEGORY_DB_PATH}")
print("Category List: ")
#from pprint import pprint
#pprint(category_list)


_startcol = 0


writer = pd.ExcelWriter('./Category_and_its_Websites.xlsx', engine='openpyxl' )

for category_name, category_website_list in category_list.items():
    df = pd.DataFrame({ category_name: category_website_list } )
    df.to_excel(writer, startcol = _startcol, index=False, sheet_name='Web Category List')
    _startcol = _startcol + 1;

writer.save()

